## libiio 0.23

=== CMakeLists.txt ===
message(STATUS "cmake version: ${CMAKE_VERSION}")
cmake_minimum_required(VERSION 2.8.7)
project(libiio C)

if (MINGW)
	set(WIN32 ON)
endif()

set(LIBIIO_VERSION_MAJOR 0)
set(LIBIIO_VERSION_MINOR 23)
set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")
if (WIN32)
	string(TIMESTAMP BUILD_YEAR "%Y")
endif()

# Set the default install path to /usr
if (NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "default install path" FORCE)
endif()

set(CMAKE_INSTALL_DOCDIR "" CACHE PATH "documentation root (DATAROOTDIR/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc)")
include(GNUInstallDirs)
if(ENABLE_SHARED AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}")
	set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()
set(CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${PROJECT_NAME}${LIBIIO_VERSION_MAJOR}-doc")

set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
	CACHE PATH "Installation directory for pkgconfig (.pc) files")
mark_as_advanced(INSTALL_PKGCONFIG_DIR)

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
		"Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Release RelWithDebInfo MinSizeRel)
endif()

option(BUILD_SHARED_LIBS "Build shared libraries" ON)

if (NOT BUILD_SHARED_LIBS)
	add_definitions(-DLIBIIO_STATIC=1)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	option(OSX_PACKAGE "Create a OSX package" ON)

	set(OSX_INSTALL_FRAMEWORKSDIR "/Library/Frameworks" CACHE STRING "Installation directory for frameworks")
	get_filename_component(OSX_INSTALL_FRAMEWORKSDIR "${OSX_INSTALL_FRAMEWORKSDIR}" REALPATH BASE_DIR "${CMAKE_BINARY_DIR}")

	set(CMAKE_MACOSX_RPATH ON)
	set(SKIP_INSTALL_ALL ${OSX_PACKAGE})
endif()

option(WITH_NETWORK_BACKEND "Enable the network backend" ON)
option(WITH_TESTS "Build the test programs" ON)
option(WITH_EXAMPLES "Build examples" OFF)

if (WITH_TESTS)
	set(NEED_THREADS 1)
endif()

if (NOT LOG_LEVEL)
	set(LOG_LEVEL Info CACHE STRING "Log level" FORCE)
	set_property(CACHE LOG_LEVEL PROPERTY STRINGS NoLog Error Warning Info Debug)
endif()

if (MSVC)
	add_compile_options(/W4 /wd4200 /wd4127 /wd4100)
	# C4200: nonstandard extension used : zero-sized array in struct (usb.h)
	# C4127: conditional expression is constant (IIO_ERROR and IIO_DEBUG macros)
	# C4100: unreferenced parameter; same as -Wno-unused-parameter

	set(CMAKE_FIND_LIBRARY_PREFIXES "lib" "")
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".dll.a" ".a" ".lib")

elseif (CMAKE_COMPILER_IS_GNUCC)
	if (NOT WIN32)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
	endif()

	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter")

	include(CheckCCompilerFlag)
	check_c_compiler_flag(-Wpedantic HAS_WPEDANTIC)
	if (HAS_WPEDANTIC)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpedantic")
	endif()
	check_c_compiler_flag(-Wshadow HAS_WSHADOW)
	if (HAS_WSHADOW)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
	endif()
	# cmake 2.8 doesn't support C_STANDARD defined in set_target_properties
	if (${CMAKE_VERSION} VERSION_LESS "3.2")
		check_c_compiler_flag(-std=c99 HAS_C99)
		if (HAS_C99)
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
		endif()
	endif()

	# Per http://www.mingw.org/wiki/Use_more_recent_defined_functions
	if (MINGW)
		# Build for Vista and above
		# check mingw-w64-headers/include/w32api.h or windows sdkddkver.h
		# https://docs.microsoft.com/en-us/cpp/porting/modifying-winver-and-win32-winnt
		# using a hex value is bad - but stops from loading the otherwise unnecessary headers
		set(CMAKE_C_FLAGS "-D_WIN32_WINNT=0x600 ${CMAKE_C_FLAGS}")
		set(CMAKE_C_FLAGS "-DWINVER=0x600 ${CMAKE_C_FLAGS}")
	endif()
elseif (CMAKE_C_COMPILER_ID STREQUAL "Clang")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -pedantic -Wno-unused-parameter")
else()
	message(STATUS "Unknown compiler, please report upstream")
	message(STATUS "CMAKE_C_COMPILER_ID : " ${CMAKE_C_COMPILER_ID})
	message(STATUS "CFLAGS set to " ${CMAKE_C_FLAGS})
endif()

# based on host, set these on macos
if(APPLE)
	#full Single Unix Standard v3 (SUSv3) conformance (the Unix API)
	add_definitions(-D_DARWIN_C_SOURCE)
elseif (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD|DragonFly|OpenBSD|NetBSD")
	set(CMAKE_REQUIRED_DEFINITIONS "-D__BSD_VISIBLE")
	add_definitions(-D__BSD_VISIBLE=1)
endif()
add_definitions(-D_POSIX_C_SOURCE=200809L -D__XSI_VISIBLE=500 -DLIBIIO_EXPORTS=1)

include(CheckSymbolExists)
check_symbol_exists(strdup "string.h" HAS_STRDUP)
check_symbol_exists(strndup "string.h" HAS_STRNDUP)
check_symbol_exists(strerror_r "string.h" HAS_STRERROR_R)
check_symbol_exists(newlocale "locale.h" HAS_NEWLOCALE)

option(ENABLE_IPV6 "Define if you want to enable IPv6 support" ON)
if (ENABLE_IPV6)
	check_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)
	if (NOT HAVE_IPV6)
		message(SEND_ERROR "IPv6 is not available in your system.")
	endif()
endif()

option(WITH_USB_BACKEND "Enable the libusb backend" ON)
if (WITH_USB_BACKEND)
	#Handle FreeBSD libusb and Linux libusb-1.0 libraries
	find_library(LIBUSB_LIBRARIES NAMES usb-1.0 usb)
	find_path(LIBUSB_INCLUDE_DIR libusb.h PATH_SUFFIXES libusb-1.0)
	if (NOT LIBUSB_LIBRARIES OR NOT LIBUSB_INCLUDE_DIR)
		message(SEND_ERROR "Unable to find libusb-1.0 dependency.\n"
			"If you want to disable the USB backend, set WITH_USB_BACKEND=OFF.")
	else()
		message(STATUS "Looking for libusb-1.0 : Found")

		set(IIOD_CLIENT 1)
		set(NEED_LIBXML2 1)
		set(NEED_THREADS 1)

		include_directories(${LIBUSB_INCLUDE_DIR})

		set(TEMP ${CMAKE_REQUIRED_LIBRARIES})
		set(TEMP1 ${CMAKE_REQUIRED_INCLUDES})
		list(APPEND CMAKE_REQUIRED_LIBRARIES ${LIBUSB_LIBRARIES})
		list(APPEND CMAKE_REQUIRED_INCLUDES ${LIBUSB_INCLUDE_DIR})
		check_symbol_exists(libusb_get_version libusb.h HAS_LIBUSB_GETVERSION)
		set(CMAKE_REQUIRED_LIBRARIES ${TEMP})
		set(CMAKE_REQUIRED_INCLUDES ${TEMP1})
	endif()
endif()

# make sure all check_symbol_exists are before this point, otherwise they fail
# on some versions of compilers
if (MSVC)
	if(DEFINED ENV{CI} AND DEFINED ENV{APPVEYOR})
		message(STATUS "Running in an AppVeyor environment, setting -Werror")
		add_compile_options(/WX)
	endif()
elseif (CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
	option(WITH_GCOV "Build with gcov profiling flags" OFF)
	if (WITH_GCOV)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage")
		SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
		SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}  -fprofile-arcs -ftest-coverage")
	endif()
	if(DEFINED ENV{CI} AND (DEFINED ENV{TRAVIS} OR DEFINED ENV{APPVEYOR}))
		message(STATUS "Running in CI environment (Travis or AppVeyor), setting -Werror")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
	endif()
endif()

IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	option(WITH_IIOD "Build the IIO Daemon" ON)
	option(WITH_LOCAL_BACKEND "Enable the local backend" ON)

	if (WITH_IIOD AND NOT WITH_LOCAL_BACKEND)
		message(SEND_ERROR "IIOD can only be enabled if the local backend is enabled")
	endif()
	if (WITH_IIOD)
		set(NEED_THREADS 1)
	endif()
endif()

set(LIBIIO_CFILES backend.c channel.c device.c context.c buffer.c utilities.c scan.c sort.c)
set(LIBIIO_HEADERS iio.h)

if(WITH_USB_BACKEND)
	list(APPEND LIBIIO_CFILES usb.c)
	list(APPEND LIBS_TO_LINK ${LIBUSB_LIBRARIES})
endif()

# Get the GIT hash of the latest commit
include(FindGit OPTIONAL)
if (GIT_FOUND)
	execute_process(
		COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE LIBIIO_GIT_REPO
		OUTPUT_STRIP_TRAILING_WHITESPACE
		ERROR_QUIET
	)

	if ("${LIBIIO_GIT_REPO}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
		execute_process(
			COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE LIBIIO_VERSION_GIT
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	endif()
endif()

set(LIBIIO_VERSION  ${VERSION}.g${LIBIIO_VERSION_GIT})
file(WRITE ${CMAKE_BINARY_DIR}/.version ${LIBIIO_VERSION})

if (NOT LIBIIO_VERSION_GIT)
	set(LIBIIO_VERSION_GIT v${VERSION})
endif()

if(WITH_LOCAL_BACKEND)
	list(APPEND LIBIIO_CFILES local.c)

	# Link with librt if present
	find_library(LIBRT_LIBRARIES rt)
	if (LIBRT_LIBRARIES)
		list(APPEND LIBS_TO_LINK ${LIBRT_LIBRARIES})
	endif()

	option(WITH_LOCAL_CONFIG "Read local context attributes from /etc/libiio.ini" ON)
	if (WITH_LOCAL_CONFIG)
		list(APPEND LIBIIO_CFILES ./libini/libini.c)
	endif()
endif()

option(WITH_SERIAL_BACKEND "Enable the serial backend" OFF)
if (WITH_SERIAL_BACKEND)
	find_library(LIBSERIALPORT_LIBRARIES serialport)
	find_path(LIBSERIALPORT_INCLUDE_DIR libserialport.h)
	if (NOT LIBSERIALPORT_LIBRARIES OR NOT LIBSERIALPORT_INCLUDE_DIR)
		message(SEND_ERROR "Unable to find libserialport dependency.\n")
	else()
		message(STATUS "Looking for libserialport : Found")

		file(STRINGS ${LIBSERIALPORT_INCLUDE_DIR}/libserialport.h LIBSERIALPORT_VERSION_STR REGEX "SP_PACKAGE_VERSION_STRING")
		string(REGEX REPLACE "#define SP_PACKAGE_VERSION_STRING \"(.*)\"" "\\1" LIBSERIALPORT_VERSION ${LIBSERIALPORT_VERSION_STR})
		if ("${LIBSERIALPORT_VERSION}" VERSION_LESS 0.1.1)
			message(SEND_ERROR "The installed version of libserialport is too old. The minimum version supported is 0.1.1.")
		endif()

		list(APPEND LIBIIO_CFILES serial.c)
		list(APPEND LIBS_TO_LINK ${LIBSERIALPORT_LIBRARIES})

		set(NEED_THREADS 1)
		set(IIOD_CLIENT 1)
		set(NEED_LIBXML2 1)

		include_directories(${LIBSERIALPORT_INCLUDE_DIR})
	endif()
endif()

option(WITH_ZSTD "Support for ZSTD compressed metadata" OFF)
if (WITH_ZSTD)
	find_library(LIBZSTD_LIBRARIES zstd)
	find_path(LIBZSTD_INCLUDE_DIR zstd.h)

	if (NOT LIBZSTD_LIBRARIES OR NOT LIBZSTD_INCLUDE_DIR)
		message(SEND_ERROR "Unable to find libzstd dependency.\n"
			"If you want to disable ZSTD compression support, set WITH_ZSTD=OFF.")
	endif()

	list(APPEND LIBS_TO_LINK ${LIBZSTD_LIBRARIES})
	include_directories(${LIBZSTD_INCLUDE_DIR})
endif (WITH_ZSTD)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

if(WITH_NETWORK_BACKEND)
	message(STATUS "Building with Network back end support")
	if (WIN32)
		list(APPEND LIBS_TO_LINK wsock32 iphlpapi ws2_32)
	endif()

	if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
		option(WITH_NETWORK_GET_BUFFER "Enable experimental zero-copy transfers" OFF)
		if (WITH_NETWORK_GET_BUFFER)
			include(CheckCSourceCompiles)
			check_c_source_compiles("#define _GNU_SOURCE=1\n#include <fcntl.h>\nint main(void) { return O_TMPFILE; }"
				HAS_O_TMPFILE)

			if (NOT HAS_O_TMPFILE)
				message(SEND_ERROR "Zero-copy requires the O_TMPFILE flag, which is not available on the system.")
			endif()
		endif()

		check_c_source_compiles("#include <sys/eventfd.h>\nint main(void) { return eventfd(0, EFD_CLOEXEC | EFD_NONBLOCK); }"
			WITH_NETWORK_EVENTFD)
		if (NOT WITH_NETWORK_EVENTFD)
			check_c_source_compiles("#define _GNU_SOURCE=1\n#include <unistd.h>\n#include <fcntl.h>\nint main(void) { int fd[2]; return pipe2(fd, O_CLOEXEC | O_NONBLOCK); }"
				HAS_PIPE2)
		endif()

		if (WITH_NETWORK_GET_BUFFER OR HAS_PIPE2)
			add_definitions(-D_GNU_SOURCE=1)
		endif()
	endif()

	list(APPEND LIBIIO_CFILES network.c)
	if (WIN32)
		list(APPEND LIBIIO_CFILES network-windows.c)
	else()
		list(APPEND LIBIIO_CFILES network-unix.c)
	endif()

	option(HAVE_DNS_SD "Enable DNS-SD (ZeroConf) support" ON)
	if (NOT HAVE_DNS_SD)
		message(STATUS "Building without DNS-SD (ZeroConf) support")
	elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
		find_library(CORE_SERVICES CoreServices)

		message(STATUS "Building with CFNetServices, an Apple DNS SD implementation")

		list(APPEND LIBIIO_CFILES dns_sd_bonjour.c dns_sd.c)
		list(APPEND LIBS_TO_LINK ${CORE_SERVICES} )

	elseif(WIN32)
		list(APPEND LIBIIO_CFILES dns_sd_windows.c dns_sd.c)

=== bindings/CMakeLists.txt ===
if (CSHARP_BINDINGS)
	add_subdirectory(csharp)
endif()

if (PYTHON_BINDINGS)
	add_subdirectory(python)
endif()

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(ad9361-iiostream C)
project(ad9371-iiostream C)
project(adrv9009-iiostream C)
project(dummy-iiostream C)
project(adrv9002-iiostream C)

if (APPLE)
    # Add relative rpath to iio library (which is in the same framework)
    set(CMAKE_INSTALL_RPATH "@executable_path/../..")
    set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
endif ()

if (MSVC)
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src)
    set(GETOPT_C_FILE
        ${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src/getopt.c
    )
endif (MSVC)

if (WIN32)
    set(LIBIIO_ORIGINAL_FILENAME)
    set(LIBIIO_RC ${CMAKE_CURRENT_BINARY_DIR}/properties.rc)
    configure_file(../properties.rc.cmakein ${LIBIIO_RC} @ONLY)
endif ()

if (CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DIIO_CHECK_RET")
endif ()

add_executable(
    ad9361-iiostream ad9361-iiostream.c ${GETOPT_C_FILE} ${LIBIIO_RC}
)
add_executable(
    ad9371-iiostream ad9371-iiostream.c ${GETOPT_C_FILE} ${LIBIIO_RC}
)
add_executable(
    adrv9009-iiostream adrv9009-iiostream.c ${GETOPT_C_FILE} ${LIBIIO_RC}
)
add_executable(
    adrv9002-iiostream adrv9002-iiostream.c ${GETOPT_C_FILE} ${LIBIIO_RC}
)
add_executable(dummy-iiostream dummy-iiostream.c ${GETOPT_C_FILE} ${LIBIIO_RC})

target_link_libraries(ad9361-iiostream iio)
target_link_libraries(ad9371-iiostream iio)
target_link_libraries(adrv9009-iiostream iio)
target_link_libraries(dummy-iiostream iio)
target_link_libraries(adrv9002-iiostream iio)

set(IIO_EXAMPLES_TARGETS ad9361-iiostream ad9371-iiostream adrv9009-iiostream
                         dummy-iiostream adrv9002-iiostream
)

find_library(PTHREAD_LIBRARIES pthread)
find_library(CURSES_LIBRARY curses)
find_library(CDK_LIBRARY cdk)

include(CheckSymbolExists)

if (PTHREAD_LIBRARIES
    AND CURSES_LIBRARY
    AND CDK_LIBRARY
)
    find_path(LIBCKD_INCLUDE_DIR cdk.h PATH_SUFFIXES cdk)

    set(TEMP ${CMAKE_REQUIRED_LIBRARIES})
    set(TEMP1 ${CMAKE_REQUIRED_INCLUDES})
    list(APPEND CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARY} ${CDK_LIBRARY})
    list(APPEND CMAKE_REQUIRED_INCLUDES ${LIBCKD_INCLUDE_DIR})
    check_symbol_exists(CDK_CSTRING2 "cdk.h" HAS_CDK_CSTRING2)
    set(CMAKE_REQUIRED_LIBRARIES ${TEMP})
    set(CMAKE_REQUIRED_INCLUDES ${TEMP1})
endif()

if(HAS_CDK_CSTRING2)
    include_directories(${LIBCKD_INCLUDE_DIR})
    project(iio-monitor C)
    add_executable(iio-monitor iio-monitor.c)
    target_link_libraries(
        iio-monitor iio ${PTHREAD_LIBRARIES} ${CURSES_LIBRARY} ${CDK_LIBRARY}
    )
    set(IIO_TESTS_TARGETS ${IIO_TESTS_TARGETS} iio-monitor)
else()
    message(STATUS "Curses Development Kit (CDK) missing or too old, skipping iio-monitor")
endif ()

set_target_properties(
    ${IIO_TESTS_TARGETS} PROPERTIES C_STANDARD 99 C_STANDARD_REQUIRED ON
                                    C_EXTENSIONS OFF
)

# We don't install any of these, they are examples, not tools. We build them to
# make sure they build/work, not to deploy them.

=== iiod/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(iiod C)

include(FindBISON)
include(FindFLEX)

flex_target(lexer
	${CMAKE_CURRENT_SOURCE_DIR}/lexer.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.c)
bison_target(parser
	${CMAKE_CURRENT_SOURCE_DIR}/parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.c)
add_flex_bison_dependency(lexer parser)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

include(CheckSymbolExists)
set(CMAKE_REQUIRED_LIBRARIES ${PTHREAD_LIBRARIES})
set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(pthread_setname_np "pthread.h" HAS_PTHREAD_SETNAME_NP)
set(CMAKE_REQUIRED_LIBRARIES)
set(CMAKE_REQUIRED_DEFINITIONS)

if (CMAKE_C_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCC)
	# flex sometimes generates code which generate sign comparison errors
	set_source_files_properties(${FLEX_lexer_OUTPUTS} PROPERTIES COMPILE_FLAGS "-Wno-sign-compare")
	set_source_files_properties(${BISON_parser_OUTPUTS} PROPERTIES COMPILE_FLAGS "-Wno-sign-compare")
endif ()

set(IIOD_CFILES iiod.c ops.c thread-pool.c ${BISON_parser_OUTPUTS} ${FLEX_lexer_OUTPUTS})

option(WITH_AIO "Build IIOD with async. I/O support" ON)
if (WITH_AIO)
	find_library(LIBAIO_LIBRARIES aio)
	find_path(LIBAIO_INCLUDE_DIR libaio.h)

	if (NOT LIBAIO_LIBRARIES OR NOT LIBAIO_INCLUDE_DIR)
		message(SEND_ERROR "Unable to find libaio dependency.\n"
			"If you want to disable async. I/O support, set WITH_AIO=OFF.")
	endif ()

	message(STATUS "Looking for libaio: Found")

	option(WITH_IIOD_USBD "Add support for USB through FunctionFS within IIOD" ON)
	if (WITH_IIOD_USBD)
		include(CheckTypeSize)
		set(CMAKE_EXTRA_INCLUDE_FILES linux/usb/functionfs.h)
		check_type_size("struct usb_functionfs_descs_head_v2" FUNCTIONFS_V2)
		set(CMAKE_EXTRA_INCLUDE_FILES)

		if (NOT HAVE_FUNCTIONFS_V2)
			message(SEND_ERROR "Linux kernel headers are too old.\n"
				"If you want to disable USB support, set WITH_IIOD_USBD=OFF.")
		endif()

		set(IIOD_CFILES ${IIOD_CFILES} usbd.c)
	endif()
endif()

add_executable(iiod ${IIOD_CFILES})
set_target_properties(iiod PROPERTIES
	C_STANDARD 99
	C_STANDARD_REQUIRED ON
	C_EXTENSIONS OFF
)
target_link_libraries(iiod iio ${PTHREAD_LIBRARIES} ${AVAHI_LIBRARIES})

if (WITH_AIO)
	include_directories(${LIBAIO_INCLUDE_DIR})
	target_link_libraries(iiod ${LIBAIO_LIBRARIES})
endif ()

if (WITH_ZSTD)
	include_directories(${LIBZSTD_INCLUDE_DIR})
	target_link_libraries(iiod ${LIBZSTD_LIBRARIES})
endif()

add_definitions(-D_GNU_SOURCE=1)

if (HAVE_AVAHI)
	target_sources(iiod PRIVATE dns-sd.c)
endif()

if(NOT SKIP_INSTALL_ALL)
	install(TARGETS iiod RUNTIME DESTINATION ${CMAKE_INSTALL_SBINDIR})
endif()

if (WITH_SYSTEMD)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.service.cmakein ${PROJECT_BINARY_DIR}/init/iiod.service)
	install(FILES ${PROJECT_BINARY_DIR}/init/iiod.service DESTINATION ${SYSTEMD_UNIT_INSTALL_DIR})
endif()

if (WITH_SYSVINIT)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.init.cmakein ${PROJECT_BINARY_DIR}/init/iiod)
	install(FILES ${PROJECT_BINARY_DIR}/init/iiod
	        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
	        DESTINATION ${SYSVINIT_INSTALL_DIR})
endif()

if (WITH_UPSTART)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.conf.cmakein ${PROJECT_BINARY_DIR}/init/iiod.conf)
	install(FILES ${PROJECT_BINARY_DIR}/init/iiod.conf DESTINATION ${UPSTART_CONF_INSTALL_DIR})
endif()

=== man/CMakeLists.txt ===
if (WITH_MAN)
	find_program(BASH_EXECUTABLE bash)
	find_program(DATE_EXECUTABLE date)
	if (DEFINED ENV{SOURCE_DATE_EPOCH})
		execute_process(
			COMMAND ${DATE_EXECUTABLE} "-u" "-d" "@$ENV{SOURCE_DATE_EPOCH}" "+%d %B %Y"
			OUTPUT_VARIABLE CMAKE_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
	else ()
		execute_process(
			COMMAND ${DATE_EXECUTABLE} "+%d %B %Y"
			OUTPUT_VARIABLE CMAKE_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
	endif ()
	configure_file(
		${CMAKE_CURRENT_SOURCE_DIR}/make_man.sh.in
		${CMAKE_CURRENT_BINARY_DIR}/make_man.sh @ONLY)
	execute_process(
		COMMAND ${BASH_EXECUTABLE} "-c" "${CMAKE_CURRENT_BINARY_DIR}/make_man.sh > ${CMAKE_BINARY_DIR}/libiio.3.in"
		)
	configure_file(
		${CMAKE_BINARY_DIR}/libiio.3.in
		${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/libiio.3 @ONLY)

	if (WITH_DOC)
		find_program(MAN2HTML man2html)
		if (NOT MAN2HTML)
			message(FATAL_ERROR "Can not build html DOC from man without man2html")
		endif()
		message(STATUS "Building html doc pages with man2html")
		file(MAKE_DIRECTORY ${CMAKE_HTML_DEST_DIR}/man3)
		execute_process(
			COMMAND ${MAN2HTML} -r
			INPUT_FILE ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/libiio.3
			OUTPUT_FILE ${CMAKE_HTML_DEST_DIR}/man3/libiio.3.html
		)
	endif()
	if (WITH_TESTS)
		list(APPEND MAN1 iio_attr.1 iio_info.1 iio_readdev.1 iio_reg.1 iio_writedev.1)
		foreach(_page ${MAN1})
			configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/${_page}.in
				${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/${_page} @ONLY)
		endforeach()
		if (WITH_DOC)
			file(MAKE_DIRECTORY ${CMAKE_HTML_DEST_DIR}/man1)
			foreach(_page ${MAN1})
				execute_process(
					COMMAND ${MAN2HTML} -r
					INPUT_FILE ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}/${_page}
					OUTPUT_FILE ${CMAKE_HTML_DEST_DIR}/man1/${_page}.html
				)
			endforeach()
		endif()
	endif()
	# install man files into the BINARY directories,
	# section 3 = library functions
	install(DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}
		DESTINATION ${CMAKE_INSTALL_MANDIR}/man3
		COMPONENT doc FILES_MATCHING PATTERN "*.3*")
	# section 1 = user commands
	install(DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}
		DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
		COMPONENT doc FILES_MATCHING PATTERN "*.1*")

endif()

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)

project(iio_genxml  C)
project(iio_info    C)
project(iio_attr    C)
project(iio_readdev C)
project(iio_reg     C)

if(APPLE)
	# Add relative rpath to iio library (which is in the same framework)
	set(CMAKE_INSTALL_RPATH "@executable_path/../..")
	set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
endif()

if (MSVC)
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src)
	set(GETOPT_C_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../deps/wingetopt/src/getopt.c)
	set_source_files_properties(${GETOPT_C_FILE} PROPERTIES COMPILE_FLAGS -D_CRT_SECURE_NO_WARNINGS=1)
endif (MSVC)

if (WIN32)
	set(LIBIIO_ORIGINAL_FILENAME )
	set(LIBIIO_RC ${CMAKE_CURRENT_BINARY_DIR}/properties.rc)
	configure_file(../properties.rc.cmakein ${LIBIIO_RC} @ONLY)
endif()

if (CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DIIO_CHECK_RET")
endif()
add_library(iio_tests_helper STATIC iio_common.c gen_code.c)
target_link_libraries(iio_tests_helper iio)

add_executable(iio_genxml  iio_genxml.c   ${GETOPT_C_FILE} ${LIBIIO_RC})
add_executable(iio_info    iio_info.c     ${GETOPT_C_FILE} ${LIBIIO_RC})
add_executable(iio_attr    iio_attr.c     ${GETOPT_C_FILE} ${LIBIIO_RC})
add_executable(iio_readdev iio_readdev.c  ${GETOPT_C_FILE} ${LIBIIO_RC})
add_executable(iio_reg     iio_reg.c      ${GETOPT_C_FILE} ${LIBIIO_RC})
add_executable(iio_writedev iio_writedev.c  ${GETOPT_C_FILE} ${LIBIIO_RC})

target_link_libraries(iio_genxml  iio iio_tests_helper)
target_link_libraries(iio_info    iio iio_tests_helper)
target_link_libraries(iio_attr    iio iio_tests_helper)
target_link_libraries(iio_readdev iio iio_tests_helper)
target_link_libraries(iio_reg     iio iio_tests_helper)
target_link_libraries(iio_writedev iio iio_tests_helper)

set(IIO_TESTS_TARGETS iio_genxml iio_info iio_attr iio_readdev iio_reg iio_writedev)

if(PTHREAD_LIBRARIES OR ANDROID)
	project(iio_adi_xflow_check C)
	project(iio_stresstest C)
	add_executable(iio_adi_xflow_check iio_adi_xflow_check.c)
	add_executable(iio_stresstest iio_stresstest.c)
	target_link_libraries(iio_adi_xflow_check iio iio_tests_helper ${PTHREAD_LIBRARIES})
	target_link_libraries(iio_stresstest iio iio_tests_helper ${PTHREAD_LIBRARIES})
	set(IIO_TESTS_TARGETS ${IIO_TESTS_TARGETS} iio_adi_xflow_check iio_stresstest)

	target_link_libraries(iio_readdev  ${PTHREAD_LIBRARIES})
	target_link_libraries(iio_writedev ${PTHREAD_LIBRARIES})
endif()

set_target_properties(${IIO_TESTS_TARGETS} PROPERTIES
	C_STANDARD 99
	C_STANDARD_REQUIRED ON
	C_EXTENSIONS OFF
)

if(NOT SKIP_INSTALL_ALL)
	if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
		install(TARGETS ${IIO_TESTS_TARGETS} RUNTIME DESTINATION ${OSX_INSTALL_FRAMEWORKSDIR}/iio.framework/Tools)
	else()
		install(TARGETS ${IIO_TESTS_TARGETS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
	endif()
endif()

# Make the test targets available to the main CMakeLists.txt
set(IIO_TESTS_TARGETS ${IIO_TESTS_TARGETS} PARENT_SCOPE)

=== debian/changelog ===
libiio (0.23-2) unstable; urgency=medium

  * update to v0.23-26-gfbf5adb2

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 27 Nov 2021 19:41:07 -0500

libiio (0.23-1) experimental; urgency=medium

  * New upstream release
  * update to v0.23-19-g4e574547

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 09 Nov 2021 21:56:32 -0500

=== debian/control ===
Source: libiio
Section: libs
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: bison,
               cmake,
               debhelper (>= 13~),
	       debhelper-compat (= 13),
               dh-python,
               doxygen,
               flex,
	       graphviz,
	       libaio-dev,
	       libavahi-client-dev,
	       libcdk5-dev,
	       libserialport-dev,
	       libudev-dev [linux-any],
	       libusb-1.0-0-dev [linux-any],
	       libusb2-dev [kfreebsd-any],
	       libxml2-dev,
	       man2html,
	       python3-dev,
	       python3-setuptools,
	       python3-sphinx,
	       python3-sphinx-rtd-theme
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://github.com/analogdevicesinc/libiio
Vcs-Browser: https://salsa.debian.org/debian/libiio
Vcs-Git: https://salsa.debian.org/debian/libiio.git

Package: libiio0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: avahi-daemon
Description: Library for interfacing with IIO devices
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the shared library.

Package: libiio-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiio0 (= ${binary:Version}), ${misc:Depends}
Description: libiio development files
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the development files.

Package: iiod
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: libiio0 (>= ${binary:Version}),
         lsb-base (>=3.0-6),
	 ${misc:Depends},
         ${shlibs:Depends}
Section: net
Suggests: avahi-daemon
Description: Daemon to share IIO devices on the network
 IIOD is a network daemon that communicates with the network backend of libiio.
 It can be used, for instance, to stream the flow of data samples from one weak
 system to a more powerful one, where the samples will be processed.

Package: libiio-utils
Architecture: any
Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Miscellaneous libiio utilities
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains several basic utilities for testing libiio.

Package: python3-libiio
Section: python
Architecture: all
Depends: libiio0 (>= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
Description: Python bindings for libiio
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the Python bindings for libiio.

Package: libiio0-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-sphinxdoc, libjs-jquery, libjs-underscore, ${misc:Depends}
Description: libiio documentation
 Libiio is a library that has been conceived to ease the development of
 applications interfacing Industrial Input/Output (IIO) devices through
 the IIO subsystem of the Linux kernel.
 .
 This package contains the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddirectory=build --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_RPATH=On \
		-DPYTHON_BINDINGS=ON -DWITH_DOC=ON -DWITH_MAN=ON

override_dh_compress:
	dh_compress -X.c -X.C

override_dh_auto_install:
	dh_auto_install
	- rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/.nojekyll
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/doctools.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/ && ln -s /usr/share/javascript/sphinxdoc/1.0/doctools.js doctools.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/language_data.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/ && ln -s /usr/share/javascript/sphinxdoc/1.0/language_data.js language_data.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/searchtools.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/ && ln -s /usr/share/javascript/sphinxdoc/1.0/searchtools.js searchtools.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/jquery.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/ && ln -s /usr/share/javascript/jquery/jquery.js jquery.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/underscore.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.23/python/_static/ && ln -s /usr/share/javascript/underscore/underscore.js underscore.js

## libiio 0.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,14 +7,14 @@
 endif()
 
 set(LIBIIO_VERSION_MAJOR 0)
-set(LIBIIO_VERSION_MINOR 23)
+set(LIBIIO_VERSION_MINOR 24)
 set(VERSION "${LIBIIO_VERSION_MAJOR}.${LIBIIO_VERSION_MINOR}")
 if (WIN32)
 	string(TIMESTAMP BUILD_YEAR "%Y")
 endif()
 
 # Set the default install path to /usr
-if (NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
+if (NOT APPLE AND NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
 	set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "default install path" FORCE)
 endif()
 
@@ -43,7 +43,8 @@
 	add_definitions(-DLIBIIO_STATIC=1)
 endif()
 
-if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+option(OSX_FRAMEWORK "Create a OSX_FRAMEWORK" ON)
+if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND OSX_FRAMEWORK)
 	option(OSX_PACKAGE "Create a OSX package" ON)
 
 	set(OSX_INSTALL_FRAMEWORKSDIR "/Library/Frameworks" CACHE STRING "Installation directory for frameworks")
@@ -67,7 +68,9 @@
 endif()
 
 if (MSVC)
-	add_compile_options(/W4 /wd4200 /wd4127 /wd4100)
+	add_compile_options(/Zi /W4 /wd4200 /wd4127 /wd4100)
+	# Zi produces a separate PDB file that contains all the symbolic debugging information
+	# W4 displays level 1, 2, 3, and 4 (informational) warnings that aren't off by default
 	# C4200: nonstandard extension used : zero-sized array in struct (usb.h)
 	# C4127: conditional expression is constant (IIO_ERROR and IIO_DEBUG macros)
 	# C4100: unreferenced parameter; same as -Wno-unused-parameter
@@ -130,11 +133,16 @@
 check_symbol_exists(strdup "string.h" HAS_STRDUP)
 check_symbol_exists(strndup "string.h" HAS_STRNDUP)
 check_symbol_exists(strerror_r "string.h" HAS_STRERROR_R)
+check_symbol_exists(strtok_r "string.h" HAS_STRTOK_R)
 check_symbol_exists(newlocale "locale.h" HAS_NEWLOCALE)
 
 option(ENABLE_IPV6 "Define if you want to enable IPv6 support" ON)
 if (ENABLE_IPV6)
-	check_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)
+	if (WIN32)
+		set(HAVE_IPV6 ON)
+	else()
+		check_symbol_exists(in6addr_any "netinet/in.h" HAVE_IPV6)
+	endif()
 	if (NOT HAVE_IPV6)
 		message(SEND_ERROR "IPv6 is not available in your system.")
 	endif()
@@ -142,15 +150,22 @@
 
 option(WITH_USB_BACKEND "Enable the libusb backend" ON)
 if (WITH_USB_BACKEND)
-	#Handle FreeBSD libusb and Linux libusb-1.0 libraries
-	find_library(LIBUSB_LIBRARIES NAMES usb-1.0 usb)
+	find_package(PkgConfig)
+	if (PkgConfig_FOUND)
+		pkg_check_modules(LIBUSB libusb-1.0)
+		if (NOT LIBUSB_FOUND)
+			#Handle FreeBSD libusb and Linux libusb-1.0 libraries
+			find_library(LIBUSB_LIBRARIES NAMES usb-1.0 usb)
+		else()
+			set(LIBUSB_LIBRARIES ${LIBUSB_LINK_LIBRARIES})
+		endif()
+	endif()
 	find_path(LIBUSB_INCLUDE_DIR libusb.h PATH_SUFFIXES libusb-1.0)
 	if (NOT LIBUSB_LIBRARIES OR NOT LIBUSB_INCLUDE_DIR)
 		message(SEND_ERROR "Unable to find libusb-1.0 dependency.\n"
 			"If you want to disable the USB backend, set WITH_USB_BACKEND=OFF.")
 	else()
-		message(STATUS "Looking for libusb-1.0 : Found")
-
+		list(APPEND LIBIIO_SCAN_BACKENDS usb)
 		set(IIOD_CLIENT 1)
 		set(NEED_LIBXML2 1)
 		set(NEED_THREADS 1)
@@ -170,8 +185,12 @@
 # make sure all check_symbol_exists are before this point, otherwise they fail
 # on some versions of compilers
 if (MSVC)
-	if(DEFINED ENV{CI} AND DEFINED ENV{APPVEYOR})
-		message(STATUS "Running in an AppVeyor environment, setting -Werror")
+	# why can't different CIs use the same flags?
+	# Travis CI      : CI=True & TRAVIS=True
+	# Appveyor       : CI=True & APPVEYOR=True
+	# Azure Pipelines: TF_BUILD=True
+	if(DEFINED ENV{TF_BUILD} OR (DEFINED ENV{CI} AND DEFINED ENV{APPVEYOR}))
+		message(STATUS "Running in an Azure or AppVeyor environment, setting -Werror")
 		add_compile_options(/WX)
 	endif()
 elseif (CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID STREQUAL "Clang")
@@ -181,10 +200,13 @@
 		SET(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage")
 		SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS}  -fprofile-arcs -ftest-coverage")
 	endif()
-	if(DEFINED ENV{CI} AND (DEFINED ENV{TRAVIS} OR DEFINED ENV{APPVEYOR}))
-		message(STATUS "Running in CI environment (Travis or AppVeyor), setting -Werror")
+	if(DEFINED ENV{TF_BUILD} OR (DEFINED ENV{CI} AND (DEFINED ENV{TRAVIS} OR DEFINED ENV{APPVEYOR})))
+		message(STATUS "Running in CI environment (Azure, Travis or AppVeyor), setting -Werror")
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
 	endif()
+else()
+	message(STATUS "Unknown compiler ${CMAKE_C_COMPILER_ID}")
+	message(STATUS "GCC ${CMAKE_COMPILER_IS_GNUCC}")
 endif()
 
 IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
@@ -246,8 +268,13 @@
 
 	option(WITH_LOCAL_CONFIG "Read local context attributes from /etc/libiio.ini" ON)
 	if (WITH_LOCAL_CONFIG)
-		list(APPEND LIBIIO_CFILES ./libini/libini.c)
-	endif()
+		list(APPEND LIBIIO_CFILES ./deps/libini/libini.c)
+	endif()
+
+	option(WITH_LOCAL_MMAP_API "Use the mmap API provided in Analog Devices' kernel (not upstream)" ON)
+	option(WITH_HWMON "Add compatibility with the hardware monitoring (hwmon) subsystem" OFF)
+
+	list(APPEND LIBIIO_SCAN_BACKENDS local)
 endif()
 
 option(WITH_SERIAL_BACKEND "Enable the serial backend" OFF)
@@ -293,15 +320,15 @@
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
 
 if(WITH_NETWORK_BACKEND)
-	message(STATUS "Building with Network back end support")
 	if (WIN32)
 		list(APPEND LIBS_TO_LINK wsock32 iphlpapi ws2_32)
 	endif()
 
 	if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+		include(CheckCSourceCompiles)
+
 		option(WITH_NETWORK_GET_BUFFER "Enable experimental zero-copy transfers" OFF)
 		if (WITH_NETWORK_GET_BUFFER)
-			include(CheckCSourceCompiles)
 			check_c_source_compiles("#define _GNU_SOURCE=1\n#include <fcntl.h>\nint main(void) { return O_TMPFILE; }"
 				HAS_O_TMPFILE)
 
@@ -310,35 +337,3 @@
 			endif()
 		endif()
 
-		check_c_source_compiles("#include <sys/eventfd.h>\nint main(void) { return eventfd(0, EFD_CLOEXEC | EFD_NONBLOCK); }"
-			WITH_NETWORK_EVENTFD)
-		if (NOT WITH_NETWORK_EVENTFD)
-			check_c_source_compiles("#define _GNU_SOURCE=1\n#include <unistd.h>\n#include <fcntl.h>\nint main(void) { int fd[2]; return pipe2(fd, O_CLOEXEC | O_NONBLOCK); }"
-				HAS_PIPE2)
-		endif()
-
-		if (WITH_NETWORK_GET_BUFFER OR HAS_PIPE2)
-			add_definitions(-D_GNU_SOURCE=1)
-		endif()
-	endif()
-
-	list(APPEND LIBIIO_CFILES network.c)
-	if (WIN32)
-		list(APPEND LIBIIO_CFILES network-windows.c)
-	else()
-		list(APPEND LIBIIO_CFILES network-unix.c)
-	endif()
-
-	option(HAVE_DNS_SD "Enable DNS-SD (ZeroConf) support" ON)
-	if (NOT HAVE_DNS_SD)
-		message(STATUS "Building without DNS-SD (ZeroConf) support")
-	elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-		find_library(CORE_SERVICES CoreServices)
-
-		message(STATUS "Building with CFNetServices, an Apple DNS SD implementation")
-
-		list(APPEND LIBIIO_CFILES dns_sd_bonjour.c dns_sd.c)
-		list(APPEND LIBS_TO_LINK ${CORE_SERVICES} )
-
-	elseif(WIN32)
-		list(APPEND LIBIIO_CFILES dns_sd_windows.c dns_sd.c)

=== bindings/CMakeLists.txt ===
--- 
+++ 
@@ -5,3 +5,9 @@
 if (PYTHON_BINDINGS)
 	add_subdirectory(python)
 endif()
+
+list(APPEND IIOB_FEATURES_${PYTHON_BINDINGS} python-bindings)
+list(APPEND IIOB_FEATURES_${CSHARP_BINDINGS} "c#-bindings")
+
+set(IIOB_FEATURES_ON "${IIOB_FEATURES_ON}" PARENT_SCOPE)
+set(IIOB_FEATURES_OFF "${IIOB_FEATURES_OFF}" PARENT_SCOPE)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -69,7 +69,10 @@
     set(TEMP1 ${CMAKE_REQUIRED_INCLUDES})
     list(APPEND CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARY} ${CDK_LIBRARY})
     list(APPEND CMAKE_REQUIRED_INCLUDES ${LIBCKD_INCLUDE_DIR})
+    set(TMP_FLAGS "${CMAKE_C_FLAGS}")
+    set(CMAKE_C_FLAGS "")
     check_symbol_exists(CDK_CSTRING2 "cdk.h" HAS_CDK_CSTRING2)
+    set(CMAKE_C_FLAGS "${TMP_FLAGS}")
     set(CMAKE_REQUIRED_LIBRARIES ${TEMP})
     set(CMAKE_REQUIRED_INCLUDES ${TEMP1})
 endif()

=== iiod/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,10 @@
 include(CheckSymbolExists)
 set(CMAKE_REQUIRED_LIBRARIES ${PTHREAD_LIBRARIES})
 set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
+set(TMP_FLAGS "${CMAKE_C_FLAGS}")
+set(CMAKE_C_FLAGS "")
 check_symbol_exists(pthread_setname_np "pthread.h" HAS_PTHREAD_SETNAME_NP)
+set(CMAKE_C_FLAGS "${TMP_FLAGS}")
 set(CMAKE_REQUIRED_LIBRARIES)
 set(CMAKE_REQUIRED_DEFINITIONS)
 
@@ -37,8 +40,6 @@
 			"If you want to disable async. I/O support, set WITH_AIO=OFF.")
 	endif ()
 
-	message(STATUS "Looking for libaio: Found")
-
 	option(WITH_IIOD_USBD "Add support for USB through FunctionFS within IIOD" ON)
 	if (WITH_IIOD_USBD)
 		include(CheckTypeSize)
@@ -53,6 +54,11 @@
 
 		set(IIOD_CFILES ${IIOD_CFILES} usbd.c)
 	endif()
+endif()
+
+option(WITH_IIOD_SERIAL "Add serial (UART) support" ON)
+if (WITH_IIOD_SERIAL)
+	set(IIOD_CFILES ${IIOD_CFILES} serial.c)
 endif()
 
 add_executable(iiod ${IIOD_CFILES})
@@ -99,3 +105,13 @@
 	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/init/iiod.conf.cmakein ${PROJECT_BINARY_DIR}/init/iiod.conf)
 	install(FILES ${PROJECT_BINARY_DIR}/init/iiod.conf DESTINATION ${UPSTART_CONF_INSTALL_DIR})
 endif()
+
+list(APPEND IIOD_FEATURES_${WITH_IIOD_SERIAL} iiod-serial)
+list(APPEND IIOD_FEATURES_${WITH_AIO} iiod-aio)
+list(APPEND IIOD_FEATURES_${WITH_IIOD_USBD} iiod-usb)
+list(APPEND IIOD_FEATURES_${WITH_SYSTEMD} iiod-systemd)
+list(APPEND IIOD_FEATURES_${WITH_SYSVINIT} iiod-sysvinit)
+list(APPEND IIOD_FEATURES_${WITH_UPSTART} iiod-upstart)
+
+set(IIOD_FEATURES_ON "${IIOD_FEATURES_ON}" PARENT_SCOPE)
+set(IIOD_FEATURES_OFF "${IIOD_FEATURES_OFF}" PARENT_SCOPE)

=== man/CMakeLists.txt ===
--- 
+++ 
@@ -59,5 +59,10 @@
 	install(DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_MANDIR}
 		DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
 		COMPONENT doc FILES_MATCHING PATTERN "*.1*")
+endif()
 
-endif()
+list(APPEND IIOM_FEATURES_${WITH_MAN} man)
+list(APPEND IIOM_FEATURES_${WITH_TESTS} man-utils)
+
+set(IIOM_FEATURES_ON "${IIOM_FEATURES_ON}" PARENT_SCOPE)
+set(IIOM_FEATURES_OFF "${IIOM_FEATURES_OFF}" PARENT_SCOPE)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -37,6 +37,16 @@
 add_executable(iio_reg     iio_reg.c      ${GETOPT_C_FILE} ${LIBIIO_RC})
 add_executable(iio_writedev iio_writedev.c  ${GETOPT_C_FILE} ${LIBIIO_RC})
 
+if (MSVC)
+	target_link_options(iio_tests_helper PUBLIC /DEBUG)
+	target_link_options(iio_genxml   PUBLIC /DEBUG)
+	target_link_options(iio_info     PUBLIC /DEBUG)
+	target_link_options(iio_attr     PUBLIC /DEBUG)
+	target_link_options(iio_readdev  PUBLIC /DEBUG)
+	target_link_options(iio_reg      PUBLIC /DEBUG)
+	target_link_options(iio_writedev PUBLIC /DEBUG)
+endif()
+
 target_link_libraries(iio_genxml  iio iio_tests_helper)
 target_link_libraries(iio_info    iio iio_tests_helper)
 target_link_libraries(iio_attr    iio iio_tests_helper)
@@ -59,14 +69,14 @@
 	target_link_libraries(iio_writedev ${PTHREAD_LIBRARIES})
 endif()
 
-set_target_properties(${IIO_TESTS_TARGETS} PROPERTIES
+set_target_properties(${IIO_TESTS_TARGETS} iio_tests_helper PROPERTIES
 	C_STANDARD 99
 	C_STANDARD_REQUIRED ON
 	C_EXTENSIONS OFF
 )
 
 if(NOT SKIP_INSTALL_ALL)
-	if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+	if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND OSX_FRAMEWORK)
 		install(TARGETS ${IIO_TESTS_TARGETS} RUNTIME DESTINATION ${OSX_INSTALL_FRAMEWORKSDIR}/iio.framework/Tools)
 	else()
 		install(TARGETS ${IIO_TESTS_TARGETS} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== bindings/python/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
project(libiio-py NONE)

if(${CMAKE_VERSION} VERSION_LESS "3.12.0") 
	message(STATUS "bin=${PYTHON_EXECUTABLE} lib=${PYTHON_LIBRARY} inc=${PYTHON_INCLUDE_DIR}")
	include(FindPythonInterp)

	# Set variables as they would be set by module FindPython,
	# which is available from CMake 3.12.
	set(Python_Interpreter_FOUND ${PYTHONINTERP_FOUND})
	set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
else()
	if(PYTHON_EXECUTABLE)
		set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
	endif()
	if (PYTHON_LIBRARY)
		set(Python_LIBRARY ${PYTHON_LIBRARY})
	endif()
	if (PYTHON_INCLUDE_DIR)
		set(Python_INCLUDE_DIR ${PYTHON_INCLUDE_DIR})
	endif()
	message(STATUS "bin=${Python_EXECUTABLE} lib=${Python_LIBRARY} inc=${Python_INCLUDE_DIR}")
	find_package (Python COMPONENTS Interpreter)
	message(STATUS "Python_EXECUTABLE ${Python_EXECUTABLE}")
endif()

if (Python_Interpreter_FOUND)
	set(SETUP_PY_IN ${CMAKE_CURRENT_SOURCE_DIR}/setup.py.cmakein)
	set(SETUP_PY ${CMAKE_CURRENT_BINARY_DIR}/setup.py)

	configure_file(${SETUP_PY_IN} ${SETUP_PY})

	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/iio.py  ${CMAKE_CURRENT_BINARY_DIR}/iio.py COPYONLY)

	add_custom_target(libiio-py ALL DEPENDS ${SETUP_PY} COMMAND ${Python_EXECUTABLE} ${SETUP_PY} --quiet build)

	if(NOT SKIP_INSTALL_ALL)
		install(CODE "execute_process(WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} COMMAND ${Python_EXECUTABLE} ${SETUP_PY} install --root=\$ENV{DESTDIR}/ --prefix=${CMAKE_INSTALL_PREFIX})")
	endif()
else()
	message(FATAL_ERROR "Python search failed : Can not build Python bindings")
endif()

if(WITH_DOC)
	if(${CMAKE_VERSION} VERSION_LESS "3.2.0")
		# cmake -E env was added in 3.2
		message(FATAL_ERROR "Sorry, you can't build python doc with ancient cmake, please update")
	endif()
	find_program(SPHINX_EXECUTABLE
		NAMES sphinx-build
		DOC "Sphinx Documentation Builder (sphinx-doc.org)"
	)
	if (NOT SPHINX_EXECUTABLE)
		message(FATAL_ERROR "Can not build python doc without sphinx-build")
	endif()
	message (STATUS "Building with Python Doc (Sphinx)")
	configure_file(
		${CMAKE_CURRENT_SOURCE_DIR}/doc/conf.py.in
		${CMAKE_CURRENT_SOURCE_DIR}/doc/conf.py)
	add_custom_command(TARGET libiio-py POST_BUILD
		COMMAND ${CMAKE_COMMAND} -E env "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:${CMAKE_BINARY_DIR}"
		${SPHINX_EXECUTABLE}
			-b html
			-n
			-c ${CMAKE_CURRENT_SOURCE_DIR}/doc
			-d ${CMAKE_CURRENT_BINARY_DIR}/doctrees
			-w ${CMAKE_BINARY_DIR}/Spx_output_python
			${CMAKE_CURRENT_SOURCE_DIR}/doc
			${CMAKE_HTML_DEST_DIR}/python
		COMMENT "Generating Python binding documentation with Sphinx" VERBATIM
	)
endif()

=== deps/wingetopt/CMakeLists.txt ===
PROJECT(wingetopt)
cmake_minimum_required(VERSION 2.8)

option(BUILD_SHARED_LIBS "Build the shared library" OFF)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

add_definitions(-D_CRT_SECURE_NO_WARNINGS)

if(BUILD_SHARED_LIBS)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
  add_definitions(-DBUILDING_WINGETOPT_DLL -DWINGETOPT_SHARED_LIB)
endif()

add_library(wingetopt src/getopt.c src/getopt.h)

install(FILES src/getopt.h DESTINATION include)

install(TARGETS wingetopt
    RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	ARCHIVE DESTINATION lib)

=== debian/changelog ===
libiio (0.24-4) unstable; urgency=medium

  [ A. Maitland Bottoms ]
  * install the right iiod.service file for iiod
  * edit previous changelog entry for correctness
  * Include the following Debian Janitor improvements from salsa.
  
  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix day-of-week for changelog entry 0.6.

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 23 Jan 2023 21:16:11 -0500

libiio (0.24-3) unstable; urgency=medium

  * fix python-libiio.install (Closes: #1021086)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 21 Jan 2023 17:37:55 -0400

libiio (0.24-2) unstable; urgency=medium

  * update python install (Closes: #1020104)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 21 Sep 2022 23:10:28 -0400

libiio (0.24-1) unstable; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 10 Jul 2022 12:23:05 -0400

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
 	       python3-setuptools,
 	       python3-sphinx,
 	       python3-sphinx-rtd-theme
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/analogdevicesinc/libiio
 Vcs-Browser: https://salsa.debian.org/debian/libiio
@@ -58,7 +58,6 @@
 Architecture: linux-any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libiio0 (>= ${binary:Version}),
-         lsb-base (>=3.0-6),
 	 ${misc:Depends},
          ${shlibs:Depends}
 Section: net

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddirectory=build --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_INSTALL_RPATH=On -DWITH_SYSTEMD=On -DWITH_SYSVINIT=On \
		-DPYTHON_BINDINGS=ON -DWITH_DOC=ON -DWITH_MAN=ON

override_dh_compress:
	dh_compress -X.c -X.C

override_dh_auto_install:
	dh_auto_install
	- rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/.nojekyll
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/doctools.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/ && ln -s /usr/share/javascript/sphinxdoc/1.0/doctools.js doctools.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/language_data.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/ && ln -s /usr/share/javascript/sphinxdoc/1.0/language_data.js language_data.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/searchtools.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/ && ln -s /usr/share/javascript/sphinxdoc/1.0/searchtools.js searchtools.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/jquery.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/ && ln -s /usr/share/javascript/jquery/jquery.js jquery.js
	rm -f debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/underscore.js
	cd debian/tmp/usr/share/doc/libiio0-doc/v0.24/python/_static/ && ln -s /usr/share/javascript/underscore/underscore.js underscore.js
